<?php

namespace App\Http\Middleware;

use Closure;
use Illuminate\Support\Facades\Log;
use App\Exceptions\ModelNotFoundException;
use App\Models\Usuario;

class IsColegaMiddleware {
    public function handle($request, Closure $next) {
        $loged_user = $request->user;
        $user = Usuario::findOrFail($request->route('id'));

        if(!$loged_user->isColega($user)) {
            Log::debug('El usuario intento acceder a los datos de otro usuario que no es su colega', [
                'loged_user' => $loged_user->id,
                'user' => $user->id
            ]);
            throw new ModelNotFoundException('usuario', $user->id);
        } else {
            Log::debug('El usuario accedio a los datos de otro usuario que si es su colega', [
                'loged_user' => $loged_user->id,
                'user' => $user->id
            ]);
        }

        return $next($request);
    }
}
